CisFu = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "FuBarPlugin-2.0")
CisFu.version = "1.0." .. string.sub("$Revision: 29149 $", 12, -3);
CisFu.date = string.sub("$Date: 2007-02-27 11:01:01 -0500 (Tue, 27 Feb 2007) $", 8, 17);
CisFu.hasIcon = "Interface\\GroupFrame\\UI-Group-LeaderIcon"
CisFu.cannotDetachTooltip = true
CisFu.hideWithoutStandby = true
CisFu:RegisterDB("CisDB")

local Tablet = AceLibrary("Tablet-2.0")


CisFu.options = {
	desc = 'Shows information about all your characters',
	handler = CisFu,
	type = 'group',
	args = {
		menu = {
			name = 'CharacterInfo',
			desc = 'Show Character Info Menu',
			type = 'execute',
			func = function() CharacterInfoStorage:ToggleUI() end,
		},
		inventory = {
			name = 'StoreInventory',
			desc = 'Store characters equipped items',
			type = 'toggle',
			get = function() return CharacterInfoStorage:StoringInventory() end,
			set = function(val) CharacterInfoStorage:SetInventory(val) end,
		},
		bags = {
			name = 'StoreBags',
			desc = 'Store characters bag content',
			type = 'toggle',
			get = function() return CharacterInfoStorage:StoringBags() end,
			set = function(val) CharacterInfoStorage:SetBags(val) end,
		},
		bank = {
			name = 'StoreBank',
			desc = 'Store characters bank content (including bank bags)',
			type = 'toggle',
			get = function() return CharacterInfoStorage:StoringBank() end,
			set = function(val) CharacterInfoStorage:SetBank(val) end,
		},
		keyring = {
			name = 'StoreKeyring',
			desc = 'Store characters keyring content',
			type = 'toggle',
			get = function() return CharacterInfoStorage:StoringKeyring() end,
			set = function(val) CharacterInfoStorage:SetKeyring(val) end,
		},
		purge = {
			name = 'Purge',
			desc = 'Removes information that is not to be stored from all characters. Warning! Will use current setting to determing what to remove from all characters.',
			type = 'execute',
			func = function() CharacterInfoStorage:Purge() end,
		},
		update = {
			name = 'Update',
			desc = 'Force a complete update of this character',
			type = 'execute',
			func = function() CharacterInfoStorage:InitPlayer() end,
		},
		remove = {
			name = 'Remove',
			desc = 'Removes information about a character',
			type = 'text',
			usage = '<charactername>',
			get = false,
			set = function(v) CharacterInfoStorage:Remove(v) end,
		},
		position = {
			name = 'Save Position',
			desc = 'Remember frame position',
			type = 'toggle',
			get = function() return CharacterInfoStorage.db.profile.SavePosition end,
			set = function(val) CharacterInfoStorage.db.profile.SavePosition = val end,
		},
		strata = {
			name = 'Frame Strata',
			desc = 'Select frame strata',
			type = 'text',
			get = function() return CharacterInfoStorage.db.profile.FrameStrata end,
			set = function(val) CharacterInfoStorage.db.profile.FrameStrata = val end,
			validate = { "LOW", "MEDIUM", "HIGH" },
		},
	}
}

CisFu.OnMenuRequest = CisFu.options

function CisFu:OnClick()
	CharacterInfoStorage:ToggleUI()
end

function CisFu:OnTextUpdate()
	self:SetText("CharInfo")
end

function CisFu:OnTooltipUpdate()
	Tablet:SetHint("\nLeft-click to display CharacterInfo\nRight-click to display menu")
end